diff --git a/src/backend/access/gin/ginget.c b/src/backend/access/gin/ginget.c
index fc85ba99ac..55f05eb65d 100644
--- a/src/backend/access/gin/ginget.c
+++ b/src/backend/access/gin/ginget.c
@@ -111,9 +111,9 @@ scanPostingTree(Relation index, GinScanEntry scanEntry,
  * 1. Partial-match support: scan from current point until the
  *	  comparePartialFn says we're done.
  * 2. SEARCH_MODE_ALL: scan from current point (which should be first
- *	  key for the current attnum) until we hit null items or end of attnum
+ *	  key for the current attphysnum) until we hit null items or end of attphysnum
  * 3. SEARCH_MODE_EVERYTHING: scan from current point (which should be first
- *	  key for the current attnum) until we hit end of attnum
+ *	  key for the current attphysnum) until we hit end of attphysnum
  *
  * Returns true if done, false if it's necessary to restart scan from scratch
  */
@@ -121,7 +121,7 @@ static bool
 collectMatchBitmap(GinBtreeData *btree, GinBtreeStack *stack,
 				   GinScanEntry scanEntry, Snapshot snapshot)
 {
-	OffsetNumber attnum;
+	OffsetNumber attphysnum;
 	Form_pg_attribute attr;
 
 	/* Initialize empty bitmap result */
@@ -133,8 +133,8 @@ collectMatchBitmap(GinBtreeData *btree, GinBtreeStack *stack,
 		return true;
 
 	/* Locate tupdesc entry for key column (for attbyval/attlen data) */
-	attnum = scanEntry->attnum;
-	attr = TupleDescAttr(btree->ginstate->origTupdesc, attnum - 1);
+	attphysnum = scanEntry->attphysnum;
+	attr = TupleDescAttr(btree->ginstate->origTupdesc, attphysnum - 1);
 
 	/*
 	 * Predicate lock entry leaf page, following pages will be locked by
@@ -162,7 +162,7 @@ collectMatchBitmap(GinBtreeData *btree, GinBtreeStack *stack,
 		/*
 		 * If tuple stores another attribute then stop scan
 		 */
-		if (gintuple_get_attrnum(btree->ginstate, itup) != attnum)
+		if (gintuple_get_attrnum(btree->ginstate, itup) != attphysnum)
 			return true;
 
 		/* Safe to fetch attribute value */
@@ -189,8 +189,8 @@ collectMatchBitmap(GinBtreeData *btree, GinBtreeStack *stack,
 			 * case cmp < 0 => not match and continue scan
 			 *----------
 			 */
-			cmp = DatumGetInt32(FunctionCall4Coll(&btree->ginstate->comparePartialFn[attnum - 1],
-												  btree->ginstate->supportCollation[attnum - 1],
+			cmp = DatumGetInt32(FunctionCall4Coll(&btree->ginstate->comparePartialFn[attphysnum - 1],
+												  btree->ginstate->supportCollation[attphysnum - 1],
 												  scanEntry->queryKey,
 												  idatum,
 												  UInt16GetDatum(scanEntry->strategy),
@@ -209,7 +209,7 @@ collectMatchBitmap(GinBtreeData *btree, GinBtreeStack *stack,
 			/*
 			 * In ALL mode, we are not interested in null items, so we can
 			 * stop if we get to a null-item placeholder (which will be the
-			 * last entry for a given attnum).  We do want to include NULL_KEY
+			 * last entry for a given attphysnum).  We do want to include NULL_KEY
 			 * and EMPTY_ITEM entries, though.
 			 */
 			if (icategory == GIN_CAT_NULL_ITEM)
@@ -274,7 +274,7 @@ collectMatchBitmap(GinBtreeData *btree, GinBtreeStack *stack,
 				page = BufferGetPage(stack->buffer);
 				itup = (IndexTuple) PageGetItem(page, PageGetItemId(page, stack->off));
 
-				if (gintuple_get_attrnum(btree->ginstate, itup) == attnum)
+				if (gintuple_get_attrnum(btree->ginstate, itup) == attphysnum)
 				{
 					Datum		newDatum;
 					GinNullCategory newCategory;
@@ -282,7 +282,7 @@ collectMatchBitmap(GinBtreeData *btree, GinBtreeStack *stack,
 					newDatum = gintuple_get_key(btree->ginstate, itup,
 												&newCategory);
 
-					if (ginCompareEntries(btree->ginstate, attnum,
+					if (ginCompareEntries(btree->ginstate, attphysnum,
 										  newDatum, newCategory,
 										  idatum, icategory) == 0)
 						break;	/* Found! */
@@ -299,7 +299,7 @@ collectMatchBitmap(GinBtreeData *btree, GinBtreeStack *stack,
 			ItemPointer ipd;
 			int			nipd;
 
-			ipd = ginReadTuple(btree->ginstate, scanEntry->attnum, itup, &nipd);
+			ipd = ginReadTuple(btree->ginstate, scanEntry->attphysnum, itup, &nipd);
 			tbm_add_tuples(scanEntry->matchBitmap, ipd, nipd, false);
 			scanEntry->predictNumberResult += GinGetNPosting(itup);
 			pfree(ipd);
@@ -340,7 +340,7 @@ restartScanEntry:
 	 * we should find entry, and begin scan of posting tree or just store
 	 * posting list in memory
 	 */
-	ginPrepareEntryScan(&btreeEntry, entry->attnum,
+	ginPrepareEntryScan(&btreeEntry, entry->attphysnum,
 						entry->queryKey, entry->queryCategory,
 						ginstate);
 	stackEntry = ginFindLeafPage(&btreeEntry, true, false, snapshot);
@@ -457,7 +457,7 @@ restartScanEntry:
 							  snapshot);
 			if (GinGetNPosting(itup) > 0)
 			{
-				entry->list = ginReadTuple(ginstate, entry->attnum, itup,
+				entry->list = ginReadTuple(ginstate, entry->attphysnum, itup,
 										   &entry->nlist);
 				entry->predictNumberResult = entry->nlist;
 
@@ -1553,7 +1553,7 @@ matchPartialInPendingList(GinState *ginstate, Page page,
 	{
 		itup = (IndexTuple) PageGetItem(page, PageGetItemId(page, off));
 
-		if (gintuple_get_attrnum(ginstate, itup) != entry->attnum)
+		if (gintuple_get_attrnum(ginstate, itup) != entry->attphysnum)
 			return false;
 
 		if (datumExtracted[off - 1] == false)
@@ -1574,8 +1574,8 @@ matchPartialInPendingList(GinState *ginstate, Page page,
 		 * case cmp < 0 => not match and continue scan
 		 *----------
 		 */
-		cmp = DatumGetInt32(FunctionCall4Coll(&ginstate->comparePartialFn[entry->attnum - 1],
-											  ginstate->supportCollation[entry->attnum - 1],
+		cmp = DatumGetInt32(FunctionCall4Coll(&ginstate->comparePartialFn[entry->attphysnum - 1],
+											  ginstate->supportCollation[entry->attphysnum - 1],
 											  entry->queryKey,
 											  datum[off - 1],
 											  UInt16GetDatum(entry->strategy),
@@ -1658,7 +1658,7 @@ collectMatchesForHeapRow(IndexScanDesc scan, pendingPosition *pos)
 
 				/*
 				 * Interesting tuples are from pos->firstOffset to
-				 * pos->lastOffset and they are ordered by (attnum, Datum) as
+				 * pos->lastOffset and they are ordered by (attphysnum, Datum) as
 				 * it's done in entry tree.  So we can use binary search to
 				 * avoid linear scanning.
 				 */
@@ -1672,12 +1672,12 @@ collectMatchesForHeapRow(IndexScanDesc scan, pendingPosition *pos)
 
 					attrnum = gintuple_get_attrnum(&so->ginstate, itup);
 
-					if (key->attnum < attrnum)
+					if (key->attphysnum < attrnum)
 					{
 						StopHigh = StopMiddle;
 						continue;
 					}
-					if (key->attnum > attrnum)
+					if (key->attphysnum > attrnum)
 					{
 						StopLow = StopMiddle + 1;
 						continue;
@@ -1711,7 +1711,7 @@ collectMatchesForHeapRow(IndexScanDesc scan, pendingPosition *pos)
 					else
 					{
 						res = ginCompareEntries(&so->ginstate,
-												entry->attnum,
+												entry->attphysnum,
 												entry->queryKey,
 												entry->queryCategory,
 												datum[StopMiddle - 1],
diff --git a/src/backend/access/gin/gininsert.c b/src/backend/access/gin/gininsert.c
index ea1c4184fb..a25ee278a5 100644
--- a/src/backend/access/gin/gininsert.c
+++ b/src/backend/access/gin/gininsert.c
@@ -51,7 +51,7 @@ addItemPointersToLeafTuple(GinState *ginstate,
 						   ItemPointerData *items, uint32 nitem,
 						   GinStatsData *buildStats, Buffer buffer)
 {
-	OffsetNumber attnum;
+	OffsetNumber attphysnum;
 	Datum		key;
 	GinNullCategory category;
 	IndexTuple	res;
@@ -63,11 +63,11 @@ addItemPointersToLeafTuple(GinState *ginstate,
 
 	Assert(!GinIsPostingTree(old));
 
-	attnum = gintuple_get_attrnum(ginstate, old);
+	attphysnum = gintuple_get_attrnum(ginstate, old);
 	key = gintuple_get_key(ginstate, old, &category);
 
 	/* merge the old and new posting lists */
-	oldItems = ginReadTuple(ginstate, attnum, old, &oldNPosting);
+	oldItems = ginReadTuple(ginstate, attphysnum, old, &oldNPosting);
 
 	newItems = ginMergeItemPointers(items, nitem,
 									oldItems, oldNPosting,
@@ -80,7 +80,7 @@ addItemPointersToLeafTuple(GinState *ginstate,
 	pfree(newItems);
 	if (compressedList)
 	{
-		res = GinFormTuple(ginstate, attnum, key, category,
+		res = GinFormTuple(ginstate, attphysnum, key, category,
 						   (char *) compressedList,
 						   SizeOfGinPostingList(compressedList),
 						   newNPosting,
@@ -109,7 +109,7 @@ addItemPointersToLeafTuple(GinState *ginstate,
 							  buildStats);
 
 		/* And build a new posting-tree-only result tuple */
-		res = GinFormTuple(ginstate, attnum, key, category, NULL, 0, 0, true);
+		res = GinFormTuple(ginstate, attphysnum, key, category, NULL, 0, 0, true);
 		GinSetPostingTree(res, postingRoot);
 	}
 	pfree(oldItems);
@@ -127,7 +127,7 @@ addItemPointersToLeafTuple(GinState *ginstate,
  */
 static IndexTuple
 buildFreshLeafTuple(GinState *ginstate,
-					OffsetNumber attnum, Datum key, GinNullCategory category,
+					OffsetNumber attphysnum, Datum key, GinNullCategory category,
 					ItemPointerData *items, uint32 nitem,
 					GinStatsData *buildStats, Buffer buffer)
 {
@@ -138,7 +138,7 @@ buildFreshLeafTuple(GinState *ginstate,
 	compressedList = ginCompressPostingList(items, nitem, GinMaxItemSize, NULL);
 	if (compressedList)
 	{
-		res = GinFormTuple(ginstate, attnum, key, category,
+		res = GinFormTuple(ginstate, attphysnum, key, category,
 						   (char *) compressedList,
 						   SizeOfGinPostingList(compressedList),
 						   nitem, false);
@@ -153,7 +153,7 @@ buildFreshLeafTuple(GinState *ginstate,
 		 * Build posting-tree-only result tuple.  We do this first so as to
 		 * fail quickly if the key is too big.
 		 */
-		res = GinFormTuple(ginstate, attnum, key, category, NULL, 0, 0, true);
+		res = GinFormTuple(ginstate, attphysnum, key, category, NULL, 0, 0, true);
 
 		/*
 		 * Initialize a new posting tree with the TIDs.
@@ -177,7 +177,7 @@ buildFreshLeafTuple(GinState *ginstate,
  */
 void
 ginEntryInsert(GinState *ginstate,
-			   OffsetNumber attnum, Datum key, GinNullCategory category,
+			   OffsetNumber attphysnum, Datum key, GinNullCategory category,
 			   ItemPointerData *items, uint32 nitem,
 			   GinStatsData *buildStats)
 {
@@ -189,7 +189,7 @@ ginEntryInsert(GinState *ginstate,
 
 	insertdata.isDelete = false;
 
-	ginPrepareEntryScan(&btree, attnum, key, category, ginstate);
+	ginPrepareEntryScan(&btree, attphysnum, key, category, ginstate);
 	btree.isBuild = (buildStats != NULL);
 
 	stack = ginFindLeafPage(&btree, false, false, NULL);
@@ -229,7 +229,7 @@ ginEntryInsert(GinState *ginstate,
 		CheckForSerializableConflictIn(ginstate->index, NULL,
 									   BufferGetBlockNumber(stack->buffer));
 		/* no match, so construct a new leaf entry */
-		itup = buildFreshLeafTuple(ginstate, attnum, key, category,
+		itup = buildFreshLeafTuple(ginstate, attphysnum, key, category,
 								   items, nitem, buildStats, stack->buffer);
 
 		/*
@@ -253,7 +253,7 @@ ginEntryInsert(GinState *ginstate,
  * This function is used only during initial index creation.
  */
 static void
-ginHeapTupleBulkInsert(GinBuildState *buildstate, OffsetNumber attnum,
+ginHeapTupleBulkInsert(GinBuildState *buildstate, OffsetNumber attphysnum,
 					   Datum value, bool isNull,
 					   ItemPointer heapptr)
 {
@@ -263,12 +263,12 @@ ginHeapTupleBulkInsert(GinBuildState *buildstate, OffsetNumber attnum,
 	MemoryContext oldCtx;
 
 	oldCtx = MemoryContextSwitchTo(buildstate->funcCtx);
-	entries = ginExtractEntries(buildstate->accum.ginstate, attnum,
+	entries = ginExtractEntries(buildstate->accum.ginstate, attphysnum,
 								value, isNull,
 								&nentries, &categories);
 	MemoryContextSwitchTo(oldCtx);
 
-	ginInsertBAEntries(&buildstate->accum, heapptr, attnum,
+	ginInsertBAEntries(&buildstate->accum, heapptr, attphysnum,
 					   entries, categories, nentries);
 
 	buildstate->indtuples += nentries;
@@ -297,15 +297,15 @@ ginBuildCallback(Relation index, ItemPointer tid, Datum *values,
 		Datum		key;
 		GinNullCategory category;
 		uint32		nlist;
-		OffsetNumber attnum;
+		OffsetNumber attphysnum;
 
 		ginBeginBAScan(&buildstate->accum);
 		while ((list = ginGetBAEntry(&buildstate->accum,
-									 &attnum, &key, &category, &nlist)) != NULL)
+									 &attphysnum, &key, &category, &nlist)) != NULL)
 		{
 			/* there could be many entries, so be willing to abort here */
 			CHECK_FOR_INTERRUPTS();
-			ginEntryInsert(&buildstate->ginstate, attnum, key, category,
+			ginEntryInsert(&buildstate->ginstate, attphysnum, key, category,
 						   list, nlist, &buildstate->buildStats);
 		}
 
@@ -329,7 +329,7 @@ ginbuild(Relation heap, Relation index, IndexInfo *indexInfo)
 	GinNullCategory category;
 	uint32		nlist;
 	MemoryContext oldCtx;
-	OffsetNumber attnum;
+	OffsetNumber attphysnum;
 
 	if (RelationGetNumberOfBlocks(index) != 0)
 		elog(ERROR, "index \"%s\" already contains data",
@@ -390,11 +390,11 @@ ginbuild(Relation heap, Relation index, IndexInfo *indexInfo)
 	oldCtx = MemoryContextSwitchTo(buildstate.tmpCtx);
 	ginBeginBAScan(&buildstate.accum);
 	while ((list = ginGetBAEntry(&buildstate.accum,
-								 &attnum, &key, &category, &nlist)) != NULL)
+								 &attphysnum, &key, &category, &nlist)) != NULL)
 	{
 		/* there could be many entries, so be willing to abort here */
 		CHECK_FOR_INTERRUPTS();
-		ginEntryInsert(&buildstate.ginstate, attnum, key, category,
+		ginEntryInsert(&buildstate.ginstate, attphysnum, key, category,
 					   list, nlist, &buildstate.buildStats);
 	}
 	MemoryContextSwitchTo(oldCtx);
@@ -467,7 +467,7 @@ ginbuildempty(Relation index)
  * (non-fast-update) insertion
  */
 static void
-ginHeapTupleInsert(GinState *ginstate, OffsetNumber attnum,
+ginHeapTupleInsert(GinState *ginstate, OffsetNumber attphysnum,
 				   Datum value, bool isNull,
 				   ItemPointer item)
 {
@@ -476,11 +476,11 @@ ginHeapTupleInsert(GinState *ginstate, OffsetNumber attnum,
 	int32		i,
 				nentries;
 
-	entries = ginExtractEntries(ginstate, attnum, value, isNull,
+	entries = ginExtractEntries(ginstate, attphysnum, value, isNull,
 								&nentries, &categories);
 
 	for (i = 0; i < nentries; i++)
-		ginEntryInsert(ginstate, attnum, entries[i], categories[i],
+		ginEntryInsert(ginstate, attphysnum, entries[i], categories[i],
 					   item, 1, NULL);
 }
 
diff --git a/src/backend/access/gin/ginlogic.c b/src/backend/access/gin/ginlogic.c
index c38c27fbae..442c338631 100644
--- a/src/backend/access/gin/ginlogic.c
+++ b/src/backend/access/gin/ginlogic.c
@@ -229,16 +229,16 @@ ginInitConsistentFunction(GinState *ginstate, GinScanKey key)
 	}
 	else
 	{
-		key->consistentFmgrInfo = &ginstate->consistentFn[key->attnum - 1];
-		key->triConsistentFmgrInfo = &ginstate->triConsistentFn[key->attnum - 1];
-		key->collation = ginstate->supportCollation[key->attnum - 1];
+		key->consistentFmgrInfo = &ginstate->consistentFn[key->attphysnum - 1];
+		key->triConsistentFmgrInfo = &ginstate->triConsistentFn[key->attphysnum - 1];
+		key->collation = ginstate->supportCollation[key->attphysnum - 1];
 
-		if (OidIsValid(ginstate->consistentFn[key->attnum - 1].fn_oid))
+		if (OidIsValid(ginstate->consistentFn[key->attphysnum - 1].fn_oid))
 			key->boolConsistentFn = directBoolConsistentFn;
 		else
 			key->boolConsistentFn = shimBoolConsistentFn;
 
-		if (OidIsValid(ginstate->triConsistentFn[key->attnum - 1].fn_oid))
+		if (OidIsValid(ginstate->triConsistentFn[key->attphysnum - 1].fn_oid))
 			key->triConsistentFn = directTriConsistentFn;
 		else
 			key->triConsistentFn = shimTriConsistentFn;
diff --git a/src/backend/access/gin/ginscan.c b/src/backend/access/gin/ginscan.c
index b776d04459..8bf5cfe7f7 100644
--- a/src/backend/access/gin/ginscan.c
+++ b/src/backend/access/gin/ginscan.c
@@ -54,7 +54,7 @@ ginbeginscan(Relation rel, int nkeys, int norderbys)
  * in which case just return it
  */
 static GinScanEntry
-ginFillScanEntry(GinScanOpaque so, OffsetNumber attnum,
+ginFillScanEntry(GinScanOpaque so, OffsetNumber attphysnum,
 				 StrategyNumber strategy, int32 searchMode,
 				 Datum queryKey, GinNullCategory queryCategory,
 				 bool isPartialMatch, Pointer extra_data)
@@ -79,8 +79,8 @@ ginFillScanEntry(GinScanOpaque so, OffsetNumber attnum,
 				prevEntry->isPartialMatch == isPartialMatch &&
 				prevEntry->strategy == strategy &&
 				prevEntry->searchMode == searchMode &&
-				prevEntry->attnum == attnum &&
-				ginCompareEntries(ginstate, attnum,
+				prevEntry->attphysnum == attphysnum &&
+				ginCompareEntries(ginstate, attphysnum,
 								  prevEntry->queryKey,
 								  prevEntry->queryCategory,
 								  queryKey,
@@ -100,7 +100,7 @@ ginFillScanEntry(GinScanOpaque so, OffsetNumber attnum,
 	scanEntry->extra_data = extra_data;
 	scanEntry->strategy = strategy;
 	scanEntry->searchMode = searchMode;
-	scanEntry->attnum = attnum;
+	scanEntry->attphysnum = attphysnum;
 
 	scanEntry->buffer = InvalidBuffer;
 	ItemPointerSetMin(&scanEntry->curItem);
@@ -140,7 +140,7 @@ ginScanKeyAddHiddenEntry(GinScanOpaque so, GinScanKey key,
 	int			i = key->nentries++;
 
 	/* strategy is of no interest because this is not a partial-match item */
-	key->scanEntry[i] = ginFillScanEntry(so, key->attnum,
+	key->scanEntry[i] = ginFillScanEntry(so, key->attphysnum,
 										 InvalidStrategy, key->searchMode,
 										 (Datum) 0, queryCategory,
 										 false, NULL);
@@ -150,7 +150,7 @@ ginScanKeyAddHiddenEntry(GinScanOpaque so, GinScanKey key,
  * Initialize the next GinScanKey using the output from the extractQueryFn
  */
 static void
-ginFillScanKey(GinScanOpaque so, OffsetNumber attnum,
+ginFillScanKey(GinScanOpaque so, OffsetNumber attphysnum,
 			   StrategyNumber strategy, int32 searchMode,
 			   Datum query, uint32 nQueryValues,
 			   Datum *queryValues, GinNullCategory *queryCategories,
@@ -175,7 +175,7 @@ ginFillScanKey(GinScanOpaque so, OffsetNumber attnum,
 	key->extra_data = extra_data;
 	key->strategy = strategy;
 	key->searchMode = searchMode;
-	key->attnum = attnum;
+	key->attphysnum = attphysnum;
 
 	/*
 	 * Initially, scan keys of GIN_SEARCH_MODE_ALL mode are marked
@@ -205,11 +205,11 @@ ginFillScanKey(GinScanOpaque so, OffsetNumber attnum,
 		queryKey = queryValues[i];
 		queryCategory = queryCategories[i];
 		isPartialMatch =
-			(ginstate->canPartialMatch[attnum - 1] && partial_matches)
+			(ginstate->canPartialMatch[attphysnum - 1] && partial_matches)
 			? partial_matches[i] : false;
 		this_extra = (extra_data) ? extra_data[i] : NULL;
 
-		key->scanEntry[i] = ginFillScanEntry(so, attnum,
+		key->scanEntry[i] = ginFillScanEntry(so, attphysnum,
 											 strategy, searchMode,
 											 queryKey, queryCategory,
 											 isPartialMatch, this_extra);
@@ -394,11 +394,11 @@ ginNewScanKey(IndexScanDesc scan)
 		if (key->searchMode != GIN_SEARCH_MODE_ALL)
 			continue;
 
-		if (!attrHasNormalScan[key->attnum - 1])
+		if (!attrHasNormalScan[key->attphysnum - 1])
 		{
 			key->excludeOnly = false;
 			ginScanKeyAddHiddenEntry(so, key, GIN_CAT_EMPTY_QUERY);
-			attrHasNormalScan[key->attnum - 1] = true;
+			attrHasNormalScan[key->attphysnum - 1] = true;
 		}
 	}
 
diff --git a/src/backend/access/gin/ginutil.c b/src/backend/access/gin/ginutil.c
index 20f470648b..caca0c4de4 100644
--- a/src/backend/access/gin/ginutil.c
+++ b/src/backend/access/gin/ginutil.c
@@ -391,7 +391,7 @@ GinInitMetabuffer(Buffer b)
  * Compare two keys of the same index column
  */
 int
-ginCompareEntries(GinState *ginstate, OffsetNumber attnum,
+ginCompareEntries(GinState *ginstate, OffsetNumber attphysnum,
 				  Datum a, GinNullCategory categorya,
 				  Datum b, GinNullCategory categoryb)
 {
@@ -404,8 +404,8 @@ ginCompareEntries(GinState *ginstate, OffsetNumber attnum,
 		return 0;
 
 	/* both not null, so safe to call the compareFn */
-	return DatumGetInt32(FunctionCall2Coll(&ginstate->compareFn[attnum - 1],
-										   ginstate->supportCollation[attnum - 1],
+	return DatumGetInt32(FunctionCall2Coll(&ginstate->compareFn[attphysnum - 1],
+										   ginstate->supportCollation[attphysnum - 1],
 										   a, b));
 }
 
@@ -486,7 +486,7 @@ cmpEntries(const void *a, const void *b, void *arg)
  * This avoids generating redundant index entries.
  */
 Datum *
-ginExtractEntries(GinState *ginstate, OffsetNumber attnum,
+ginExtractEntries(GinState *ginstate, OffsetNumber attphysnum,
 				  Datum value, bool isNull,
 				  int32 *nentries, GinNullCategory **categories)
 {
@@ -511,8 +511,8 @@ ginExtractEntries(GinState *ginstate, OffsetNumber attnum,
 	/* OK, call the opclass's extractValueFn */
 	nullFlags = NULL;			/* in case extractValue doesn't set it */
 	entries = (Datum *)
-		DatumGetPointer(FunctionCall3Coll(&ginstate->extractValueFn[attnum - 1],
-										  ginstate->supportCollation[attnum - 1],
+		DatumGetPointer(FunctionCall3Coll(&ginstate->extractValueFn[attphysnum - 1],
+										  ginstate->supportCollation[attphysnum - 1],
 										  value,
 										  PointerGetDatum(nentries),
 										  PointerGetDatum(&nullFlags)));
@@ -556,8 +556,8 @@ ginExtractEntries(GinState *ginstate, OffsetNumber attnum,
 			keydata[i].isnull = nullFlags[i];
 		}
 
-		arg.cmpDatumFunc = &ginstate->compareFn[attnum - 1];
-		arg.collation = ginstate->supportCollation[attnum - 1];
+		arg.cmpDatumFunc = &ginstate->compareFn[attphysnum - 1];
+		arg.collation = ginstate->supportCollation[attphysnum - 1];
 		arg.haveDups = false;
 		qsort_arg(keydata, *nentries, sizeof(keyEntryData),
 				  cmpEntries, (void *) &arg);
diff --git a/src/backend/access/gin/ginvacuum.c b/src/backend/access/gin/ginvacuum.c
index b4fa5f6bf8..67293adee3 100644
--- a/src/backend/access/gin/ginvacuum.c
+++ b/src/backend/access/gin/ginvacuum.c
@@ -506,7 +506,7 @@ ginVacuumEntryPage(GinVacuumState *gvs, Buffer buffer, BlockNumber *roots, uint3
 			/* If any item pointers were removed, recreate the tuple. */
 			if (items)
 			{
-				OffsetNumber attnum;
+				OffsetNumber attphysnum;
 				Datum		key;
 				GinNullCategory category;
 				GinPostingList *plist;
@@ -539,9 +539,9 @@ ginVacuumEntryPage(GinVacuumState *gvs, Buffer buffer, BlockNumber *roots, uint3
 					itup = (IndexTuple) PageGetItem(tmppage, PageGetItemId(tmppage, i));
 				}
 
-				attnum = gintuple_get_attrnum(&gvs->ginstate, itup);
+				attphysnum = gintuple_get_attrnum(&gvs->ginstate, itup);
 				key = gintuple_get_key(&gvs->ginstate, itup, &category);
-				itup = GinFormTuple(&gvs->ginstate, attnum, key, category,
+				itup = GinFormTuple(&gvs->ginstate, attphysnum, key, category,
 									(char *) plist, plistsize,
 									nitems, true);
 				if (plist)
diff --git a/src/backend/access/index/genam.c b/src/backend/access/index/genam.c
index 98af5347b9..46cce23c46 100644
--- a/src/backend/access/index/genam.c
+++ b/src/backend/access/index/genam.c
@@ -216,16 +216,16 @@ BuildIndexValueDescription(Relation indexRelation,
 		 */
 		for (keyno = 0; keyno < indnkeyatts; keyno++)
 		{
-			AttrNumber	attnum = idxrec->indkey.values[keyno];
+			AttrNumber	attphysnum = idxrec->indkey.values[keyno];
 
 			/*
-			 * Note that if attnum == InvalidAttrNumber, then this is an index
+			 * Note that if attphysnum == InvalidAttrNumber, then this is an index
 			 * based on an expression and we return no detail rather than try
 			 * to figure out what column(s) the expression includes and if the
 			 * user has SELECT rights on them.
 			 */
-			if (attnum == InvalidAttrNumber ||
-				pg_attribute_aclcheck(indrelid, attnum, GetUserId(),
+			if (attphysnum == InvalidAttrNumber ||
+				pg_attribute_aclcheck(indrelid, attphysnum, GetUserId(),
 									  ACL_SELECT) != ACLCHECK_OK)
 			{
 				/* No access, so clean up and return */
diff --git a/src/backend/access/index/indexam.c b/src/backend/access/index/indexam.c
index fe80b8b0ba..e6e8ddafea 100644
--- a/src/backend/access/index/indexam.c
+++ b/src/backend/access/index/indexam.c
@@ -767,7 +767,7 @@ index_can_return(Relation indexRelation, int attno)
  */
 RegProcedure
 index_getprocid(Relation irel,
-				AttrNumber attnum,
+				AttrNumber attphysnum,
 				uint16 procnum)
 {
 	RegProcedure *loc;
@@ -778,7 +778,7 @@ index_getprocid(Relation irel,
 
 	Assert(procnum > 0 && procnum <= (uint16) nproc);
 
-	procindex = (nproc * (attnum - 1)) + (procnum - 1);
+	procindex = (nproc * (attphysnum - 1)) + (procnum - 1);
 
 	loc = irel->rd_support;
 
@@ -801,7 +801,7 @@ index_getprocid(Relation irel,
  */
 FmgrInfo *
 index_getprocinfo(Relation irel,
-				  AttrNumber attnum,
+				  AttrNumber attphysnum,
 				  uint16 procnum)
 {
 	FmgrInfo   *locinfo;
@@ -814,7 +814,7 @@ index_getprocinfo(Relation irel,
 
 	Assert(procnum > 0 && procnum <= (uint16) nproc);
 
-	procindex = (nproc * (attnum - 1)) + (procnum - 1);
+	procindex = (nproc * (attphysnum - 1)) + (procnum - 1);
 
 	locinfo = irel->rd_supportinfo;
 
@@ -840,7 +840,7 @@ index_getprocinfo(Relation irel,
 		 */
 		if (!RegProcedureIsValid(procId))
 			elog(ERROR, "missing support function %d for attribute %d of index \"%s\"",
-				 procnum, attnum, RelationGetRelationName(irel));
+				 procnum, attphysnum, RelationGetRelationName(irel));
 
 		fmgr_info_cxt(procId, locinfo, irel->rd_indexcxt);
 
@@ -850,7 +850,7 @@ index_getprocinfo(Relation irel,
 			bytea	  **attoptions = RelationGetIndexAttOptions(irel, false);
 			MemoryContext oldcxt = MemoryContextSwitchTo(irel->rd_indexcxt);
 
-			set_fn_opclass_options(locinfo, attoptions[attnum - 1]);
+			set_fn_opclass_options(locinfo, attoptions[attphysnum - 1]);
 
 			MemoryContextSwitchTo(oldcxt);
 		}
@@ -936,7 +936,7 @@ index_store_float8_orderby_distances(IndexScanDesc scan, Oid *orderByTypes,
  * ----------------
  */
 bytea *
-index_opclass_options(Relation indrel, AttrNumber attnum, Datum attoptions,
+index_opclass_options(Relation indrel, AttrNumber attphysnum, Datum attoptions,
 					  bool validate)
 {
 	int			amoptsprocnum = indrel->rd_indam->amoptsprocnum;
@@ -946,7 +946,7 @@ index_opclass_options(Relation indrel, AttrNumber attnum, Datum attoptions,
 
 	/* fetch options support procedure if specified */
 	if (amoptsprocnum != 0)
-		procid = index_getprocid(indrel, attnum, amoptsprocnum);
+		procid = index_getprocid(indrel, attphysnum, amoptsprocnum);
 
 	if (!OidIsValid(procid))
 	{
@@ -966,7 +966,7 @@ index_opclass_options(Relation indrel, AttrNumber attnum, Datum attoptions,
 										Anum_pg_index_indclass, &isnull);
 		Assert(!isnull);
 		indclass = (oidvector *) DatumGetPointer(indclassDatum);
-		opclass = indclass->values[attnum - 1];
+		opclass = indclass->values[attphysnum - 1];
 
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
@@ -976,7 +976,7 @@ index_opclass_options(Relation indrel, AttrNumber attnum, Datum attoptions,
 
 	init_local_reloptions(&relopts, 0);
 
-	procinfo = index_getprocinfo(indrel, attnum, amoptsprocnum);
+	procinfo = index_getprocinfo(indrel, attphysnum, amoptsprocnum);
 
 	(void) FunctionCall1(procinfo, PointerGetDatum(&relopts));
 
diff --git a/src/backend/access/nbtree/nbtutils.c b/src/backend/access/nbtree/nbtutils.c
index ff260c393a..9c5f50f84f 100644
--- a/src/backend/access/nbtree/nbtutils.c
+++ b/src/backend/access/nbtree/nbtutils.c
@@ -2365,15 +2365,15 @@ _bt_keep_natts(Relation rel, IndexTuple lastleft, IndexTuple firstright,
 
 	scankey = itup_key->scankeys;
 	keepnatts = 1;
-	for (int attnum = 1; attnum <= nkeyatts; attnum++, scankey++)
+	for (int attphysnum = 1; attphysnum <= nkeyatts; attphysnum++, scankey++)
 	{
 		Datum		datum1,
 					datum2;
 		bool		isNull1,
 					isNull2;
 
-		datum1 = index_getattr(lastleft, attnum, itupdesc, &isNull1);
-		datum2 = index_getattr(firstright, attnum, itupdesc, &isNull2);
+		datum1 = index_getattr(lastleft, attphysnum, itupdesc, &isNull1);
+		datum2 = index_getattr(firstright, attphysnum, itupdesc, &isNull2);
 
 		if (isNull1 != isNull2)
 			break;
@@ -2428,7 +2428,7 @@ _bt_keep_natts_fast(Relation rel, IndexTuple lastleft, IndexTuple firstright)
 	int			keepnatts;
 
 	keepnatts = 1;
-	for (int attnum = 1; attnum <= keysz; attnum++)
+	for (int attphysnum = 1; attphysnum <= keysz; attphysnum++)
 	{
 		Datum		datum1,
 					datum2;
@@ -2436,9 +2436,9 @@ _bt_keep_natts_fast(Relation rel, IndexTuple lastleft, IndexTuple firstright)
 					isNull2;
 		Form_pg_attribute att;
 
-		datum1 = index_getattr(lastleft, attnum, itupdesc, &isNull1);
-		datum2 = index_getattr(firstright, attnum, itupdesc, &isNull2);
-		att = TupleDescAttr(itupdesc, attnum - 1);
+		datum1 = index_getattr(lastleft, attphysnum, itupdesc, &isNull1);
+		datum2 = index_getattr(firstright, attphysnum, itupdesc, &isNull2);
+		att = TupleDescAttr(itupdesc, attphysnum - 1);
 
 		if (isNull1 != isNull2)
 			break;
